diff --git a/app/Http/Controllers/Auth/SocialAuthController.php b/app/Http/Controllers/Web/Auth/SocialAuthController.php
similarity index 64%
rename from app/Http/Controllers/Auth/SocialAuthController.php
rename to app/Http/Controllers/Web/Auth/SocialAuthController.php
index 598e88c..cb0d477 100644
--- a/app/Http/Controllers/Auth/SocialAuthController.php
+++ b/app/Http/Controllers/Web/Auth/SocialAuthController.php
@@ -1,20 +1,17 @@
 <?php
 
-namespace Portal\Http\Controllers\Auth;
+namespace Portal\Http\Controllers\Web\Auth;
 
 use Authy;
 use Portal\Http\Controllers\Controller;
-use Portal\Http\Controllers\RolesController;
-use Portal\Http\Requests\Auth\Social\LoginRequest;
 use Portal\Http\Requests\Auth\Social\SaveEmailRequest;
-use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\User\UserRepository;
-use Portal\Support\Enum\UserStatus;
 use Auth;
 use Session;
 use Socialite;
 use Laravel\Socialite\Contracts\User as SocialUser;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
+use Portal\Services\Auth\Social\SocialManager;
 
 class SocialAuthController extends Controller
 {
@@ -24,16 +21,16 @@ class SocialAuthController extends Controller
     private $users;
 
     /**
-     * @var RoleRepository
+     * @var SocialManager
      */
-    private $roles;
+    private $socialManager;
 
-    public function __construct(UserRepository $users, RoleRepository $roles)
+    public function __construct(UserRepository $users, SocialManager $socialManager)
     {
         $this->middleware('guest');
 
         $this->users = $users;
-        $this->roles = $roles;
+        $this->socialManager = $socialManager;
     }
 
     /**
@@ -75,7 +72,7 @@ class SocialAuthController extends Controller
                     : redirect('login')->withErrors(trans('app.you_have_to_provide_email'));
             }
 
-            $user = $this->createOrAssociateAccountForUser($socialUser, $provider);
+            $user = $this->socialManager->associate($socialUser, $provider);
         }
 
         return $this->loginAndRedirect($user);
@@ -106,7 +103,7 @@ class SocialAuthController extends Controller
 
         $account->email = $request->get('email');
 
-        $user = $this->createOrAssociateAccountForUser($account, 'twitter');
+        $user = $this->socialManager->associate($account, 'twitter');
 
         return $this->loginAndRedirect($user);
     }
@@ -123,62 +120,6 @@ class SocialAuthController extends Controller
     }
 
     /**
-     * Create account for user authenticated via social network.
-     * If user with the same email address retrieved from social network
-     * exists in our database, just associate it with provided social account.
-     *
-     * @param SocialUser $socialUser
-     * @param $provider
-     * @return \Portal\User
-     */
-    private function createOrAssociateAccountForUser(SocialUser $socialUser, $provider)
-    {
-        $user = $this->users->findByEmail($socialUser->getEmail());
-
-        if (! $user) {
-            // User with email retrieved from social auth provider does not
-            // exist in our database. That means that we have to create new user here
-            list($firstName, $lastName) = $this->parseUserFullName($socialUser);
-
-            $role = $this->roles->findByName('User');
-
-            $user = $this->users->create([
-                'email' => $socialUser->getEmail(),
-                'password' => str_random(10),
-                'first_name' => $firstName,
-                'last_name' => $lastName,
-                'status' => UserStatus::ACTIVE,
-                'avatar' => $socialUser->getAvatar(),
-                'role_id' => $role->id
-            ]);
-
-            $this->users->updateSocialNetworks($user->id, []);
-        }
-
-        // Associate social account with user account inside our application
-        $this->users->associateSocialAccountForUser($user->id, $provider, $socialUser);
-
-        return $user;
-    }
-
-    /**
-     * Parse User's name from his social network account.
-     *
-     * @param SocialUser $user
-     * @return array
-     */
-    private function parseUserFullName(SocialUser $user)
-    {
-        $name = $user->getName();
-
-        if (strpos($name, " ") !== false) {
-            return explode(" ", $name, 2);
-        }
-
-        return [$name, ''];
-    }
-
-    /**
      * Redirect user to page where he can provide an email,
      * since email is not provided inside oAuth response.
      *
diff --git a/app/Http/Controllers/DashboardController.php b/app/Http/Controllers/Web/DashboardController.php
similarity index 96%
rename from app/Http/Controllers/DashboardController.php
rename to app/Http/Controllers/Web/DashboardController.php
index 6939e98..7f06f51 100644
--- a/app/Http/Controllers/DashboardController.php
+++ b/app/Http/Controllers/Web/DashboardController.php
@@ -1,7 +1,8 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
+use Portal\Http\Controllers\Controller;
 use Portal\Repositories\Activity\ActivityRepository;
 use Portal\Repositories\User\UserRepository;
 use Portal\Support\Enum\UserStatus;
@@ -84,6 +85,4 @@ class DashboardController extends Controller
 
         return view('dashboard.default', compact('activities'));
     }
-
-
-}
\ No newline at end of file
+}
diff --git a/app/Http/Controllers/InstallController.php b/app/Http/Controllers/Web/InstallController.php
similarity index 98%
rename from app/Http/Controllers/InstallController.php
rename to app/Http/Controllers/Web/InstallController.php
index bcb66e0..f6c295a 100644
--- a/app/Http/Controllers/InstallController.php
+++ b/app/Http/Controllers/Web/InstallController.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Artisan;
 use DB;
@@ -10,6 +10,7 @@ use Illuminate\Http\Request;
 use Input;
 use Session;
 use Settings;
+use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests;
 
 class InstallController extends Controller
diff --git a/app/Http/Controllers/PermissionsController.php b/app/Http/Controllers/Web/PermissionsController.php
similarity index 97%
rename from app/Http/Controllers/PermissionsController.php
rename to app/Http/Controllers/Web/PermissionsController.php
index f4c12de..50bc37c 100644
--- a/app/Http/Controllers/PermissionsController.php
+++ b/app/Http/Controllers/Web/PermissionsController.php
@@ -1,9 +1,10 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 use Portal\Events\Role\PermissionsUpdated;
+use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\Permission\CreatePermissionRequest;
 use Portal\Http\Requests\Permission\UpdatePermissionRequest;
 use Portal\Permission;
diff --git a/app/Http/Controllers/ProfileController.php b/app/Http/Controllers/Web/ProfileController.php
similarity index 88%
rename from app/Http/Controllers/ProfileController.php
rename to app/Http/Controllers/Web/ProfileController.php
index ed391eb..6fd6a37 100644
--- a/app/Http/Controllers/ProfileController.php
+++ b/app/Http/Controllers/Web/ProfileController.php
@@ -1,15 +1,15 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Portal\Events\User\ChangedAvatar;
 use Portal\Events\User\TwoFactorDisabled;
 use Portal\Events\User\TwoFactorEnabled;
 use Portal\Events\User\UpdatedProfileDetails;
+use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\User\EnableTwoFactorRequest;
 use Portal\Http\Requests\User\UpdateProfileDetailsRequest;
 use Portal\Http\Requests\User\UpdateProfileLoginDetailsRequest;
-use Portal\Http\Requests\User\UpdateUserRequest;
 use Portal\Repositories\Activity\ActivityRepository;
 use Portal\Repositories\Country\CountryRepository;
 use Portal\Repositories\Role\RoleRepository;
@@ -66,14 +66,13 @@ class ProfileController extends Controller
         $user = $this->theUser;
         $edit = true;
         $roles = $rolesRepo->lists();
-        $socials = $user->socialNetworks;
         $countries = [0 => 'Select a Country'] + $countryRepository->lists()->toArray();
         $socialLogins = $this->users->getUserSocialLogins($this->theUser->id);
         $statuses = UserStatus::lists();
 
         return view(
             'user/profile',
-            compact('user', 'edit', 'roles', 'countries', 'socialLogins', 'socials', 'statuses')
+            compact('user', 'edit', 'roles', 'countries', 'socialLogins', 'statuses')
         );
     }
 
@@ -106,7 +105,13 @@ class ProfileController extends Controller
             'avatar' => 'image'
         ]);
 
-        if ($name = $avatarManager->uploadAndCropAvatar($this->theUser)) {
+        $name = $avatarManager->uploadAndCropAvatar(
+            $this->theUser,
+            $request->file('avatar'),
+            $request->get('points')
+        );
+
+        if ($name) {
             return $this->handleAvatarUpdate($name);
         }
 
@@ -146,20 +151,6 @@ class ProfileController extends Controller
     }
 
     /**
-     * Update user's social networks.
-     *
-     * @param Request $request
-     * @return mixed
-     */
-    public function updateSocialNetworks(Request $request)
-    {
-        $this->users->updateSocialNetworks($this->theUser->id, $request->get('socials'));
-
-        return redirect()->route('profile')
-            ->withSuccess(trans('app.socials_updated'));
-    }
-
-    /**
      * Update user's login details.
      *
      * @param UpdateProfileLoginDetailsRequest $request
@@ -173,6 +164,7 @@ class ProfileController extends Controller
         // just remove it from $data array and do not change it
         if (trim($data['password']) == '') {
             unset($data['password']);
+
             unset($data['password_confirmation']);
         }
 
@@ -186,7 +178,7 @@ class ProfileController extends Controller
      * Enable 2FA for currently logged user.
      *
      * @param EnableTwoFactorRequest $request
-     * @return $this
+     * @return \Illuminate\Http\RedirectResponse
      */
     public function enableTwoFactorAuth(EnableTwoFactorRequest $request)
     {
@@ -210,7 +202,7 @@ class ProfileController extends Controller
     /**
      * Disable 2FA for currently logged user.
      *
-     * @return $this
+     * @return \Illuminate\Http\RedirectResponse
      */
     public function disableTwoFactorAuth()
     {
@@ -238,11 +230,12 @@ class ProfileController extends Controller
      */
     public function activity(ActivityRepository $activitiesRepo, Request $request)
     {
-        $perPage = 20;
         $user = $this->theUser;
 
         $activities = $activitiesRepo->paginateActivitiesForUser(
-            $this->theUser->id, $perPage, $request->get('search')
+            $user->id,
+            $perPage = 20,
+            $request->get('search')
         );
 
         return view('activity.index', compact('activities', 'user'));
@@ -267,18 +260,15 @@ class ProfileController extends Controller
     /**
      * Invalidate user's session.
      *
-     * @param $sessionId
+     * @param $session \stdClass Session object.
      * @param SessionRepository $sessionRepository
      * @return mixed
      */
-    public function invalidateSession($sessionId, SessionRepository $sessionRepository)
+    public function invalidateSession($session, SessionRepository $sessionRepository)
     {
-        $sessionRepository->invalidateUserSession(
-            $this->theUser->id,
-            $sessionId
-        );
+        $sessionRepository->invalidateSession($session->id);
 
         return redirect()->route('profile.sessions')
             ->withSuccess(trans('app.session_invalidated'));
     }
-}
\ No newline at end of file
+}
diff --git a/app/Http/Controllers/RolesController.php b/app/Http/Controllers/Web/RolesController.php
similarity index 94%
rename from app/Http/Controllers/RolesController.php
rename to app/Http/Controllers/Web/RolesController.php
index 2d5309e..9a58f39 100644
--- a/app/Http/Controllers/RolesController.php
+++ b/app/Http/Controllers/Web/RolesController.php
@@ -1,17 +1,14 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Cache;
-use Portal\Events\Role\Created;
-use Portal\Events\Role\Deleted;
-use Portal\Events\Role\Updated;
+use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\Role\CreateRoleRequest;
 use Portal\Http\Requests\Role\UpdateRoleRequest;
 use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\User\UserRepository;
 use Portal\Role;
-use Portal\User;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 
 /**
diff --git a/app/Http/Controllers/SettingsController.php b/app/Http/Controllers/Web/SettingsController.php
similarity index 95%
rename from app/Http/Controllers/SettingsController.php
rename to app/Http/Controllers/Web/SettingsController.php
index 25fca49..073ef5e 100644
--- a/app/Http/Controllers/SettingsController.php
+++ b/app/Http/Controllers/Web/SettingsController.php
@@ -1,10 +1,11 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Portal\Events\Settings\Updated as SettingsUpdated;
 use Illuminate\Http\Request;
 use Settings;
+use Portal\Http\Controllers\Controller;
 
 /**
  * Class SettingsController
@@ -57,7 +58,7 @@ class SettingsController extends Controller
      */
     private function updateSettings($input)
     {
-        foreach($input as $key => $value) {
+        foreach ($input as $key => $value) {
             Settings::set($key, $value);
         }
 
@@ -123,4 +124,4 @@ class SettingsController extends Controller
     {
         return view('settings.notifications');
     }
-}
\ No newline at end of file
+}
diff --git a/app/Http/Controllers/UsersController.php b/app/Http/Controllers/Web/UsersController.php
similarity index 87%
rename from app/Http/Controllers/UsersController.php
rename to app/Http/Controllers/Web/UsersController.php
index ea35f23..d4912dd 100644
--- a/app/Http/Controllers/UsersController.php
+++ b/app/Http/Controllers/Web/UsersController.php
@@ -1,12 +1,13 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
 use Portal\Events\User\Banned;
 use Portal\Events\User\Deleted;
 use Portal\Events\User\TwoFactorDisabledByAdmin;
 use Portal\Events\User\TwoFactorEnabledByAdmin;
 use Portal\Events\User\UpdatedByAdmin;
+use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\User\CreateUserRequest;
 use Portal\Http\Requests\User\EnableTwoFactorRequest;
 use Portal\Http\Requests\User\UpdateDetailsRequest;
@@ -54,9 +55,12 @@ class UsersController extends Controller
      */
     public function index()
     {
-        $perPage = 20;
+        $users = $this->users->paginate(
+            $perPage = 20,
+            Input::get('search'),
+            Input::get('status')
+        );
 
-        $users = $this->users->paginate($perPage, Input::get('search'), Input::get('status'));
         $statuses = ['' => trans('app.all')] + UserStatus::lists();
 
         return view('user.list', compact('users', 'statuses'));
@@ -71,11 +75,9 @@ class UsersController extends Controller
      */
     public function view(User $user, ActivityRepository $activities)
     {
-        $socialNetworks = $user->socialNetworks;
-
         $userActivities = $activities->getLatestActivitiesForUser($user->id, 10);
 
-        return view('user.view', compact('user', 'socialNetworks', 'userActivities'));
+        return view('user.view', compact('user', 'userActivities'));
     }
 
     /**
@@ -118,16 +120,17 @@ class UsersController extends Controller
         // status to Active by default.
         $data = $request->all() + ['status' => UserStatus::ACTIVE];
 
+        if (! array_get($data, 'country_id')) {
+            $data['country_id'] = null;
+        }
+
         // Username should be updated only if it is provided.
         // So, if it is an empty string, then we just leave it as it is.
         if (trim($data['username']) == '') {
             $data['username'] = null;
         }
 
-        $data['role_id'] = $request->role;
-
         $user = $this->users->create($data);
-        $this->users->updateSocialNetworks($user->id, []);
 
         return redirect()->route('user.list')
             ->withSuccess(trans('app.user_created'));
@@ -145,14 +148,13 @@ class UsersController extends Controller
     {
         $edit = true;
         $countries = $this->parseCountries($countryRepository);
-        $socials = $user->socialNetworks;
         $roles = $roleRepository->lists();
         $statuses = UserStatus::lists();
         $socialLogins = $this->users->getUserSocialLogins($user->id);
 
         return view(
             'user.edit',
-            compact('edit', 'user', 'countries', 'socials', 'socialLogins', 'roles', 'statuses')
+            compact('edit', 'user', 'countries', 'socialLogins', 'roles', 'statuses')
         );
     }
 
@@ -165,8 +167,14 @@ class UsersController extends Controller
      */
     public function updateDetails(User $user, UpdateDetailsRequest $request)
     {
-        $this->users->update($user->id, $request->all());
-        $this->users->setRole($user->id, $request->get('role'));
+        $data = $request->all();
+
+        if (! array_get($data, 'country_id')) {
+            $data['country_id'] = null;
+        }
+
+        $this->users->update($user->id, $data);
+        $this->users->setRole($user->id, $request->role_id);
 
         event(new UpdatedByAdmin($user));
 
@@ -203,7 +211,9 @@ class UsersController extends Controller
     {
         $this->validate($request, ['avatar' => 'image']);
 
-        if ($name = $avatarManager->uploadAndCropAvatar($user)) {
+        $name = $avatarManager->uploadAndCropAvatar($user, $request->file('avatar'));
+
+        if ($name) {
             $this->users->update($user->id, ['avatar' => $name]);
 
             event(new UpdatedByAdmin($user));
@@ -237,23 +247,6 @@ class UsersController extends Controller
     }
 
     /**
-     * Update user's social networks.
-     *
-     * @param User $user
-     * @param Request $request
-     * @return mixed
-     */
-    public function updateSocialNetworks(User $user, Request $request)
-    {
-        $this->users->updateSocialNetworks($user->id, $request->get('socials'));
-
-        event(new UpdatedByAdmin($user));
-
-        return redirect()->route('user.edit', $user->id)
-            ->withSuccess(trans('app.socials_updated'));
-    }
-
-    /**
      * Update user's login details.
      *
      * @param User $user
@@ -367,13 +360,13 @@ class UsersController extends Controller
      * Invalidate specified session for selected user.
      *
      * @param User $user
-     * @param $sessionId
+     * @param $session
      * @param SessionRepository $sessionRepository
      * @return mixed
      */
-    public function invalidateSession(User $user, $sessionId, SessionRepository $sessionRepository)
+    public function invalidateSession(User $user, $session, SessionRepository $sessionRepository)
     {
-        $sessionRepository->invalidateUserSession($user->id, $sessionId);
+        $sessionRepository->invalidateSession($session->id);
 
         return redirect()->route('user.sessions', $user->id)
             ->withSuccess(trans('app.session_invalidated'));
diff --git a/app/Http/Kernel.php b/app/Http/Kernel.php
index b5c00ff..ae3f01e 100644
--- a/app/Http/Kernel.php
+++ b/app/Http/Kernel.php
@@ -32,6 +32,7 @@ class Kernel extends HttpKernel
             \Illuminate\Routing\Middleware\SubstituteBindings::class,
         ],
         'api' => [
+            \Portal\Http\Middleware\UseApiGuard::class,
             'throttle:60,1',
             'bindings'
         ],
diff --git a/app/Http/Middleware/Authenticate.php b/app/Http/Middleware/Authenticate.php
index 5ffb56b..3bd590f 100644
--- a/app/Http/Middleware/Authenticate.php
+++ b/app/Http/Middleware/Authenticate.php
@@ -35,7 +35,7 @@ class Authenticate
     public function handle($request, Closure $next)
     {
         if ($this->auth->guest()) {
-            if ($request->ajax()) {
+            if ($request->ajax() || $request->wantsJson()) {
                 return response('Unauthorized.', 401);
             } else {
                 return redirect()->guest('login');
diff --git a/app/Http/Middleware/CheckPermissions.php b/app/Http/Middleware/CheckPermissions.php
index 5f89b39..6664738 100644
--- a/app/Http/Middleware/CheckPermissions.php
+++ b/app/Http/Middleware/CheckPermissions.php
@@ -32,8 +32,8 @@ class CheckPermissions
             $permissions = explode("|", $permissions);
         }
 
-        if ($this->auth->guest() || !$request->user()->hasPermission($permissions)) {
-            abort(403);
+        if ($this->auth->guest() || ! $request->user()->hasPermission($permissions)) {
+            abort(403, "Forbidden.");
         }
 
         return $next($request);
diff --git a/app/Http/Middleware/DatabaseSession.php b/app/Http/Middleware/DatabaseSession.php
index 29fd52b..22d6488 100644
--- a/app/Http/Middleware/DatabaseSession.php
+++ b/app/Http/Middleware/DatabaseSession.php
@@ -19,7 +19,7 @@ class DatabaseSession
         // If we are not using database session driver,
         // just display 404 page
         if (config('session.driver') != 'database') {
-            throw new NotFoundHttpException;
+            throw new NotFoundHttpException("The entity you are looking for does not exist.");
         }
 
         return $next($request);
diff --git a/app/Http/Middleware/UseApiGuard.php b/app/Http/Middleware/UseApiGuard.php
new file mode 100644
index 0000000..61c0533
--- /dev/null
+++ b/app/Http/Middleware/UseApiGuard.php
@@ -0,0 +1,40 @@
+<?php
+
+namespace Portal\Http\Middleware;
+
+use Closure;
+use Illuminate\Contracts\Auth\Factory;
+
+class UseApiGuard
+{
+    /**
+     * The Auth Factory implementation.
+     *
+     * @var Factory
+     */
+    protected $auth;
+
+    /**
+     * Create a new filter instance.
+     *
+     * @param  Factory  $auth
+     */
+    public function __construct(Factory $auth)
+    {
+        $this->auth = $auth;
+    }
+
+    /**
+     * Handle an incoming request.
+     *
+     * @param  \Illuminate\Http\Request  $request
+     * @param  \Closure  $next
+     * @return mixed
+     */
+    public function handle($request, Closure $next)
+    {
+        $this->auth->shouldUse('api');
+
+        return $next($request);
+    }
+}
diff --git a/app/Http/Requests/Activity/GetActivitiesRequest.php b/app/Http/Requests/Activity/GetActivitiesRequest.php
new file mode 100644
index 0000000..191c98b
--- /dev/null
+++ b/app/Http/Requests/Activity/GetActivitiesRequest.php
@@ -0,0 +1,28 @@
+<?php
+
+namespace Portal\Http\Requests\Activity;
+
+use Portal\Http\Requests\Request;
+use Portal\User;
+
+class GetActivitiesRequest extends Request
+{
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        return [
+            'per_page' => 'integer|max:100'
+        ];
+    }
+
+    public function messages()
+    {
+        return [
+            'per_page.max' => 'Maximum number of records per page is 100.'
+        ];
+    }
+}
diff --git a/app/Http/Requests/Auth/Social/ApiAuthenticateRequest.php b/app/Http/Requests/Auth/Social/ApiAuthenticateRequest.php
new file mode 100644
index 0000000..abe4aa6
--- /dev/null
+++ b/app/Http/Requests/Auth/Social/ApiAuthenticateRequest.php
@@ -0,0 +1,25 @@
+<?php
+
+namespace Portal\Http\Requests\Auth\Social;
+
+use Illuminate\Validation\Rule;
+use Portal\Http\Requests\Request;
+
+class ApiAuthenticateRequest extends Request
+{
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        return [
+            'network' => [
+                'required',
+                Rule::in(config('auth.social.providers'))
+            ],
+            'social_token' => 'required',
+        ];
+    }
+}
diff --git a/app/Http/Requests/BinaryFileUploadRequest.php b/app/Http/Requests/BinaryFileUploadRequest.php
new file mode 100644
index 0000000..86ee243
--- /dev/null
+++ b/app/Http/Requests/BinaryFileUploadRequest.php
@@ -0,0 +1,77 @@
+<?php
+
+namespace Portal\Http\Requests;
+
+use Illuminate\Contracts\Filesystem\Filesystem;
+use Illuminate\Http\UploadedFile;
+use Illuminate\Contracts\Validation\Validator;
+
+abstract class BinaryFileUploadRequest extends Request
+{
+    /**
+     * @var
+     */
+    private $fileName;
+
+    /**
+     * @var
+     */
+    protected $fs;
+
+    /**
+     * {@inheritdoc}
+     */
+    protected function prepareForValidation()
+    {
+        $this->fs = $this->container->make(Filesystem::class);
+
+        $this->files->set(
+            $this->fileFieldName(),
+            $this->getUploadedFile()
+        );
+    }
+
+    /**
+     * Get the file field name which will be used for storing the UploadedFile
+     * into request's FilesBag.
+     * @return string
+     */
+    protected function fileFieldName()
+    {
+        return 'file';
+    }
+
+    /**
+     * Get UploadedFile from request body.
+     * @return UploadedFile
+     */
+    protected function getUploadedFile()
+    {
+        $this->fileName = str_random(20);
+
+
+
+        $this->fs->put($this->fileName, $this->getContent());
+
+        return new UploadedFile(
+            storage_path("app/{$this->fileName}"),
+            $this->fileName,
+            $this->fs->mimeType($this->fileName),
+            null,
+            null,
+            true
+        );
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    protected function failedValidation(Validator $validator)
+    {
+        if ($this->fs->has($this->fileName)) {
+            $this->fs->delete($this->fileName);
+        }
+
+        parent::failedValidation($validator);
+    }
+}
diff --git a/app/Http/Requests/Permission/RemovePermissionRequest.php b/app/Http/Requests/Permission/RemovePermissionRequest.php
new file mode 100644
index 0000000..7961a1a
--- /dev/null
+++ b/app/Http/Requests/Permission/RemovePermissionRequest.php
@@ -0,0 +1,23 @@
+<?php
+
+namespace Portal\Http\Requests\Permission;
+
+use Portal\Http\Requests\Request;
+
+class RemovePermissionRequest extends Request
+{
+    /**
+     * Determine if the user is authorized to make this request.
+     *
+     * @return bool
+     */
+    public function authorize()
+    {
+        return $this->route('permission')->removable;
+    }
+
+    public function rules()
+    {
+        return [];
+    }
+}
diff --git a/app/Http/Requests/Role/RemoveRoleRequest.php b/app/Http/Requests/Role/RemoveRoleRequest.php
new file mode 100644
index 0000000..a36ccfe
--- /dev/null
+++ b/app/Http/Requests/Role/RemoveRoleRequest.php
@@ -0,0 +1,23 @@
+<?php
+
+namespace Portal\Http\Requests\Role;
+
+use Portal\Http\Requests\Request;
+
+class RemoveRoleRequest extends Request
+{
+    /**
+     * Determine if the user is authorized to make this request.
+     *
+     * @return bool
+     */
+    public function authorize()
+    {
+        return $this->route('role')->removable;
+    }
+
+    public function rules()
+    {
+        return [];
+    }
+}
diff --git a/app/Http/Requests/Role/UpdateRolePermissionsRequest.php b/app/Http/Requests/Role/UpdateRolePermissionsRequest.php
new file mode 100644
index 0000000..a4b4e6d
--- /dev/null
+++ b/app/Http/Requests/Role/UpdateRolePermissionsRequest.php
@@ -0,0 +1,32 @@
+<?php
+
+namespace Portal\Http\Requests\Role;
+
+use Illuminate\Validation\Rule;
+use Portal\Http\Requests\Request;
+use Portal\Permission;
+
+class UpdateRolePermissionsRequest extends Request
+{
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        $permissions = Permission::pluck('id')->toArray();
+
+        return [
+            'permissions' => 'required|array',
+            'permissions.*' => Rule::in($permissions)
+        ];
+    }
+
+    public function messages()
+    {
+        return [
+            'permissions.*' => 'Provided permission does not exist.'
+        ];
+    }
+}
diff --git a/app/Http/Requests/User/CreateUserRequest.php b/app/Http/Requests/User/CreateUserRequest.php
index 0f3f5fa..8febf77 100644
--- a/app/Http/Requests/User/CreateUserRequest.php
+++ b/app/Http/Requests/User/CreateUserRequest.php
@@ -14,12 +14,18 @@ class CreateUserRequest extends Request
      */
     public function rules()
     {
-        return [
+        $rules = [
             'email' => 'required|email|unique:users,email',
             'username' => 'unique:users,username',
             'password' => 'required|min:6|confirmed',
             'birthday' => 'date',
-            'role' => 'required|exists:roles,id'
+            'role_id' => 'required|exists:roles,id',
         ];
+
+        if ($this->get('country_id')) {
+            $rules += ['country_id' => 'exists:countries,id'];
+        }
+
+        return $rules;
     }
 }
diff --git a/app/Http/Requests/User/UpdateDetailsRequest.php b/app/Http/Requests/User/UpdateDetailsRequest.php
index fe6ff18..49539f3 100644
--- a/app/Http/Requests/User/UpdateDetailsRequest.php
+++ b/app/Http/Requests/User/UpdateDetailsRequest.php
@@ -16,7 +16,7 @@ class UpdateDetailsRequest extends Request
     {
         return [
             'birthday' => 'date',
-            'role' => 'required|exists:roles,id'
+            'role_id' => 'required|exists:roles,id'
         ];
     }
 }
diff --git a/app/Http/Requests/User/UpdateUserRequest.php b/app/Http/Requests/User/UpdateUserRequest.php
new file mode 100644
index 0000000..b403e6c
--- /dev/null
+++ b/app/Http/Requests/User/UpdateUserRequest.php
@@ -0,0 +1,31 @@
+<?php
+
+namespace Portal\Http\Requests\User;
+
+use Illuminate\Validation\Rule;
+use Portal\Http\Requests\Request;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+
+class UpdateUserRequest extends Request
+{
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        $user = $this->user();
+
+        return [
+            'email' => 'email|unique:users,email,' . $user->id,
+            'username' => 'unique:users,username,' . $user->id,
+            'password' => 'min:6|confirmed',
+            'birthday' => 'date',
+            'role_id' => 'exists:roles,id',
+            'country_id' => 'exists:countries,id',
+            'status' => Rule::in(array_keys(UserStatus::lists()))
+        ];
+    }
+}
diff --git a/app/Http/Requests/User/UploadAvatarRawRequest.php b/app/Http/Requests/User/UploadAvatarRawRequest.php
new file mode 100644
index 0000000..be45920
--- /dev/null
+++ b/app/Http/Requests/User/UploadAvatarRawRequest.php
@@ -0,0 +1,22 @@
+<?php
+
+namespace Portal\Http\Requests\User;
+
+use Portal\Http\Requests\BinaryFileUploadRequest;
+
+class UploadAvatarRawRequest extends BinaryFileUploadRequest
+{
+    public function rules()
+    {
+        return [
+            'file' => 'required|image'
+        ];
+    }
+
+    public function messages()
+    {
+        return [
+            "file.required" => 'The file is required.'
+        ];
+    }
+}
